/**
 * EverestFormsConditionalFrontend JS
 */
(function($) {

	var EverestFormsConditionalFrontend = {

		/**
		 * Start the engine.
		 */
		init: function() {
			$(document).ready(EverestFormsConditionalFrontend.ready);

			EverestFormsConditionalFrontend.bindUIActions();

			$(document)
			.find('.evf-frontend-row[conditional_rules*="conditional_logic_status"]')
			.each(function () {
				if (
					undefined !== $(this).attr("conditional_rules") &&
					"" !== $(this).attr("conditional_rules")
				) {
					var conditions = JSON.parse(
						$(this).attr("conditional_rules")
					);
				}

				if (undefined !== conditions) {
					$(this)
						.find(
							".evf-field input, .evf-field select, .evf-field textarea , .evf-field h3"
						)
						.each(function () {
							if (
								undefined !== $(this).attr("conditional_rules") &&
								"" !== $(this).attr("conditional_rules")
							) {
								var field_conditions = JSON.parse(
									$(this).attr("conditional_rules")
								);

								if (undefined !== field_conditions) {
									var updated_condtions = [];
									Object.keys(
										conditions.conditionals
									).forEach((i) => {
										var main_logic = [];
										Object.keys(
											conditions.conditionals[i]
										).forEach((j) => {
											main_logic.push(
												conditions.conditionals[i][
													j
												]
											);
											var field = $(this)
												.closest("form")
												.find(
													'[data-field-id="' +
														conditions
															.conditionals[
															i
														][j]["field"] +
														'"]'
												);
											if (
												!field.hasClass(
													"everest-forms-trigger-conditional"
												)
											) {
												field.addClass(
													"everest-forms-trigger-conditional"
												);
											}
										});
										Object.keys(
											field_conditions.conditionals
										).forEach((k) => {
											var sub_logic = [];
											Object.keys(
												field_conditions
													.conditionals[k]
											).forEach((l) => {
												/** Check conditional option for row and field. If its not same, we have to make field conditional logic option(show/hide) similar to row */
												if( field_conditions.conditional_option !==  conditions.conditional_option ) {
													if( 'greater_than' === field_conditions.conditionals[k][l].operator ) {
														field_conditions.conditionals[k][l].value = parseFloat(field_conditions.conditionals[k][l].value) + 0.000001;
													} else if ( 'less_than' === field_conditions.conditionals[k][l].operator ) {
														field_conditions.conditionals[k][l].value = parseFloat(field_conditions.conditionals[k][l].value) - 0.000001;
													}
													field_conditions.conditionals[k][l] = everest_forms_multi_part.swicthConditions( field_conditions.conditionals[k][l] );
													field_conditions.conditional_option =  conditions.conditional_option;
												}
												sub_logic.push(
													field_conditions
														.conditionals[k][l]
												);
											});
											updated_condtions.push(
												main_logic.concat(sub_logic)
											);
										});
									});
									field_conditions.conditionals =
										updated_condtions;
									$(this).attr(
										"conditional_rules",
										JSON.stringify(field_conditions)
									);
								} else {
									$(this).attr(
										"conditional_rules",
										JSON.stringify(conditions)
									);
								}
							} else {
								$(this).attr(
									"conditional_rules",
									JSON.stringify(conditions)
								);
							}
						});
				}
			});

			$(document).find('form.everest-form input,form.everest-form select,form.everest-form textarea').trigger("input").trigger('change');
		},

		ready: function() {
			$('.everest-form').each(function() {
				EverestFormsConditionalFrontend.conditionalLogicAction($(this));
			});
		},

		bindUIActions: function() {
			$(document).on('change keyup ', '.everest-forms-trigger-conditional input, .everest-forms-trigger-conditional select, .everest-forms-trigger-conditional textarea', function() {
				EverestFormsConditionalFrontend.conditionalLogicAction($(this));
			});

			$(document).on('input', '.evf-payment-price', function() {
				setTimeout(() => {
					EverestFormsConditionalFrontend.conditionalLogicAction($(this));
				}, 1);
			});
		},

		conditionalLogicAction: function(el) {
			var $this = $(el),
				$form = $this.closest('.everest-form'),
				formID = $form.attr('data-formid'),
				allFields = $form.find('.evf-frontend-row').find('.evf-frontend-grid').find('.input-text');
				var el = $form.find('.evf-submit-container ').find('.evf-submit')[0];
				allFields.push(el);
				var myObj = {};
			myObj.conditional_rules = [];

			allFields.each(function(index, el) {
				var field_id = $(this).attr('id');
				if ('undefined' !== typeof $(this).attr('conditional_rules') && '' != $(this).attr('conditional_rules')) {
					if (EverestFormsConditionalFrontend.IsJsonString($(this).attr('conditional_rules')) === true) {
						myObj.conditional_rules[field_id] = JSON.parse($(this).attr('conditional_rules'));
					}
				}

			});
			var fields = myObj.conditional_rules;
			for (var fieldID in fields) {
				var field = fields[fieldID].conditionals,
					action = fields[fieldID].conditional_option,
					field_required = fields[fieldID].required,
					matchCondition = false;
				// Groups
				for (var groupID in field) {

					var group = field[groupID],
						conditionGroup = true;

					// Rules
					for (var ruleID in group) {
						var rule = group[ruleID],
							val = '',
							conditionalRuleMatch = false,
							left = '',
							right = '';

						if ( ! rule.field ) {
							continue;
						}
						var targetInput = $( '[conditional_id="' + group[ruleID].field + '"]' );
						if ( 0 === targetInput.length ) {
							continue;
						}
						var type = targetInput.get(0).type;
						if ( 'empty' === rule.operator || 'not_empty' === rule.operator ) {
							rule.value = '';
							if ( type === 'radio' || type === 'checkbox' || type === 'payment-multiple' || type === 'payment-checkbox' || type === 'rating' || type === 'likert' || type === 'scale-rating' ) {
								$check = $form.find( '#evf-'+formID+'-field_'+group[ruleID].field+'-container input:checked' );
								if ( $check.length ) {
									$.each($check, function() {
										var value = $( this ).val();
										left = value;
									});
								}
							} else {
								left = $form.find( '#evf-'+formID+'-field_'+group[ruleID].field ).val();
								if ( ! left  ) {
									left = '';
								}
							}
						} else {
							if ( "radio" === type || "checkbox" === type ) {
								var checked = $form.find( '#evf-' + formID + '-field_' + group[ruleID].field + '-container input:checked' );

								if ( checked.length ) {
									$.each( checked, function() {
										var value = $( this ).val();
										if ( 'checkbox' === type ) {
											if ( rule.value === value ) {
												left = value;
											}
										} else {
											left = value;
										}
									});
								}
							} else if ( "select-multiple" === type ) {
								var selected = $form.find( '#evf-' + formID + '-field_' + group[ruleID].field + '-container select option:selected' );

								if ( selected.length ) {
									$.each( selected, function() {
										var value = $( this ).val();
										if ( rule.value === value ) {
											left = value;
										}
									});
								}
							} else if ( "tel" === type ) {
								left = targetInput.val().replace(/[()-\s]/g,'');
							} else if ( "hidden" === type ) {
								left = targetInput.val();
							} else {
								left = targetInput.val();
							}
						}
						right = group[ruleID].value;

						switch (rule.operator) {
							case 'is':
								conditionalRuleMatch = (left === right);
								break;
							case 'is_not':
								conditionalRuleMatch = (left !== right);
								break;
							case 'empty':
								conditionalRuleMatch = ( left.length === 0 );
								break;
							case 'not_empty':
								conditionalRuleMatch = ( left.length > 0 );
								break;
							case 'greater_than' :
								left      = left.replace( /[^0-9.]/g, '' );
								conditionalRuleMatch = ( '' !== left ) && ( EverestFormsConditionalFrontend.convertToFlot( left ) > EverestFormsConditionalFrontend.convertToFlot( right ) );
								break;
							case 'less_than' :
								console.log(left);
								left      = left.replace( /[^0-9.]/g, '' );
								conditionalRuleMatch = ( '' !== left ) && ( EverestFormsConditionalFrontend.convertToFlot( left ) < EverestFormsConditionalFrontend.convertToFlot( right ) );
								break;
						}

						if (!conditionalRuleMatch) {
							conditionGroup = false;
						break;
						}

					}

					if (conditionGroup) {
						matchCondition = true;
					}

				}
				var submitButton = $('form.everest-form').find('.evf-submit-container ').find('button[id="' + fieldID + '"]');
				if ( $('.evf-field-container').find('.everest-forms-part').length ) {
					if ( submitButton.length > 0 && '""' !== submitButton.attr('conditional_rules') ){
						setTimeout( function() {
							if ( ( matchCondition && action === 'disable') ) {
								submitButton.triggerHandler( 'evf-conditional-logic-submit', 'disable' );
							} else if ( (matchCondition && action === 'hide') || (!matchCondition && action === 'show') ) {
								submitButton.triggerHandler( 'evf-conditional-logic-submit', 'hide' );
							} else {
								submitButton.triggerHandler( 'evf-conditional-logic-submit', 'show' );
							}
						}, 1 );
					}
				} else {
					if ( submitButton.length > 0 && '""' !== submitButton.attr('conditional_rules') ){
						if ( ( matchCondition && action === 'disable') ) {
							submitButton.prop('disabled', true);
						} else if ( (matchCondition && action === 'hide') || (!matchCondition && action === 'show') ) {
							submitButton.prop('disabled', false);
							submitButton.closest(".evf-submit-container").hide();
							submitButton.closest(".evf-submit-container").find( 'button' ).attr( 'disabled', 'disabled' );
						} else {
							submitButton.prop('disabled', false);
							submitButton.closest(".evf-submit-container").show();
							submitButton.closest(".evf-submit-container").find( 'button' ).removeAttr( 'disabled' );
						}
					}
				}

				var single_field = $('form.everest-form').find('.evf-frontend-row').find('.evf-frontend-grid').find('.input-text[id="' + fieldID + '"]');
				if ((matchCondition && action === 'hide') || (!matchCondition && action !== 'hide')) {
					if (undefined != single_field.attr('data-field-type') && 'repeater-fields' == single_field.attr('data-field-type')){
						if ('repeater-fields' == single_field.closest(".evf-field").parent().parent().attr('data-field-type') ){
							single_field.closest(".evf-field").parent().parent().hide();
							single_field.closest(".evf-field").parent().parent().children().find('.evf-field input, .evf-field select, .evf-field textarea').attr('disabled', 'disabled');
							single_field.closest(".evf-field").parent().parent().children().find('.evf-field input, .evf-field select, .evf-field textarea').removeAttr('required');
						}
					}else if('conversational-forms' == single_field.closest(".evf-field").parent().attr('data-field-type')){
						single_field.closest(".evf-field").parent().hide();
						single_field.closest(".evf-field").parent().attr('id','');
						single_field.closest(".evf-field").addClass('everest-convesational-condtional-logic')
						var id = $("[id^='evf-conversational-content']").length;
						$(".evf-honeypot-container , .evf-submit-container").appendTo(
							$("#evf-conversational-content" + id).find("div.evf-field:not([style*='display: none'])")
					   );
					   single_field.closest(".evf-field").find( 'input, select' ).attr( 'disabled', 'disabled' );
						single_field.prop("required", false);
					} else {
						single_field.closest(".evf-field").hide();
						single_field.closest(".evf-field").find( 'input, select' ).attr( 'disabled', 'disabled' );
						single_field.prop("required", false);
					}
					if(action === 'hide') {
						single_field.val('');
					}
					$( document.body ).trigger('conditional_hide', [single_field.closest(".evf-field")]);
				} else {
					if (undefined != single_field.attr('data-field-type') && 'repeater-fields' == single_field.attr('data-field-type')){
						if ('repeater-fields' == single_field.closest(".evf-field").parent().parent().attr('data-field-type') ){
							single_field.closest(".evf-field").parent().parent().show();
							single_field.closest(".evf-field").parent().parent().children().find('.evf-field input, .evf-field select, .evf-field textarea').removeAttr('disabled');
							single_field.closest(".evf-field") .parent().parent().children().find('.validate-required input, .validate-required select, .validate-required textarea').prop('required', true);
						}
					}else if('conversational-forms' == single_field.closest(".evf-field").parent().attr('data-field-type')){
						single_field.closest(".evf-field").parent().show();
						var dataField = single_field.closest(".everest-convesational-condtional-logic").parent().attr('data-field-id');
						single_field.closest(".everest-convesational-condtional-logic").parent().attr('id',dataField);
						var id = $("[id^='evf-conversational-content']").length;
						$(".evf-honeypot-container , .evf-submit-container").appendTo(
							$("#" + dataField).find("div.evf-field:not([style*='display: none'])")
					   );
					   single_field.closest(".evf-field").find( 'input, select' ).removeAttr( 'disabled' );

					} else {
						single_field.closest(".evf-field").show();
						if (typeof single_field.closest(".evf-field").find( 'input, select' ).attr('data-field-visibilty') === 'undefined'){
							single_field.closest(".evf-field").find( 'input, select' ).removeAttr( 'disabled' );
						}
					}
					if (!single_field.closest(".evf-field").hasClass("evf-field-credit-card") &&
						single_field.closest(".evf-field").find("input:visible, select:visible, textarea:visible").length > 0 &&
						single_field.closest(".evf-field").hasClass("validate-required") && ! single_field.is( '.evf-conditional-logic-holder' ) ) {
						single_field.closest(".evf-field").find('input, select').attr('required', 'required');
					}



					if ( '1' === field_required && ! single_field.is( '.evf-conditional-logic-holder' ) ) {
						single_field.attr( 'required', 'required' );
					}
					$( document.body ).trigger('conditional_show', [single_field.closest(".evf-field")]);
				}
			}
		},

		/**
		 * Switch Operators for conditional logic.
		 *
		 * @param {array} conditions
		 * @returns
		 */
		swicthConditions: function( conditions ) {
			var operators = {
				'is': 'is_not',
				'is_not': 'is',
				'empty': 'not_empty',
				'not_empty': 'empty',
				'greater_than': 'less_than',
				'less_than': 'greater_than'
			};
			conditions.operator = operators[ conditions.operator];
			return conditions;
		},

		IsJsonString: function(str) {
			try {
				JSON.parse(str);
			} catch (e) {
				return false;
			}
			return true;
		},

		convertToFlot: function ( val ) {
			return ( parseFloat( val ) || 0 );
		},
	};

	EverestFormsConditionalFrontend.init();

})(jQuery);
